(function() {

// BEFORE INIT

    // Add Flatpickr CDN (JS)
    tinymce.ScriptLoader.add('https://cdnjs.cloudflare.com/ajax/libs/flatpickr/4.1.2/flatpickr.js');

// ADD PLUGIN

    tinymce.PluginManager.add( 'teamup_calendar', function( editor, url ) {

        // Add Flatpickr (Custom CSS)
        var plugin_url = url + ('/' === url.slice(-1) ? '' : '/');
        tinymce.DOM.loadCSS(plugin_url + '/css/flatpickr.css');

        // Add Button to Visual Editor Toolbar
        editor.addButton('teamup_calendar', {
            title: 'Teamup Calendar',
            cmd: 'teamup_calendar',
            image: url + '/icon.png'
        }); 

        // Add Command when Button Clicked
        editor.addCommand('teamup_calendar', function() {

            // Function getURLParameter
            function getURLParameter(parameter, string) {
              return decodeURIComponent((new RegExp('[?|&amp;]' + parameter + '=' + '([^&;]+?)(&|#|;|$)').exec(string) || [null, ''])[1]) || null;
            }

// SELECTED CONTENT

            // Selected Content in Editor
            var selectedContent = tinyMCE.activeEditor.selection.getContent();
            var isCalendar = false;
            var actionName = "Insert";

            // Form Variables
            var calendarUrl = "";
            var calendarTitle = "";
            var calendarWidth = "";
            var calendarHeight = "";

            var calendarView = "";
            var calendarMdays = "";
            var calendarMweeks = "";
            var calendarMyear = "";

            var calendarDate = "";
            var calendarDate2 = "";

            var calendarEvents = "";
            var calendarLanguage = "";
            var calendarTimezone = "";

            var calendarViewHeader = "";
            var calendarViewLogo = "";
            var calendarViewTitle = "";
            var calendarViewSidepanel = "";
            var calendarViewSelector = "";

            var calendarRefresh = "";

            // Selected Content ( Get variables )
            if (selectedContent != "") {
                selectedContent = selectedContent.split(" ");
                selectedContent.forEach(function (item) {

                    // calendarWidth
                    if(item.startsWith("width=")) {
                        item = item.slice(7);
                        item = item.slice(0,-1);
                        calendarWidth = item;
                    }

                    // calendarHeight
                    if(item.startsWith("height=")) {
                        item = item.slice(8);
                        item = item.slice(0,-1);
                        calendarHeight = item;
                    }

                    // -- Source Variables Parse --
                    if(item.startsWith("src=")) {
                        item = item.slice(5);
                        item = item.slice(0,-1);

                        // calendarUrl
                        var calendarKey = item;
                        calendarKey = calendarKey.slice(calendarKey.indexOf("teamup.com")+11);
                        calendarKey = calendarKey.substr(0, calendarKey.indexOf('?'));
                        calendarUrl = "https://teamup.com/" + calendarKey;
                        if(calendarKey != "") { isCalendar = true; actionName = "Edit"; }

                        // calendarTitle
                        if (getURLParameter("title", item) != null) {
                            var titleText = getURLParameter("title", item);
                            calendarTitle = decodeURIComponent(titleText);
                        }

                        if (getURLParameter("view", item) != null) {
                        // calendarMdays
                            if (getURLParameter("view", item).startsWith("md")) {
                                calendarView = "view=md";
                                calendarMdays = getURLParameter("view", item).slice(getURLParameter("view", item).indexOf("md")+2);
                            }
                        // calendarMweeks
                            else if (getURLParameter("view", item).startsWith("mw")) {
                                calendarView = "view=mw";
                                calendarMweeks = getURLParameter("view", item).slice(getURLParameter("view", item).indexOf("mw")+2);
                            }
                        // calendarMyear
                            else if (getURLParameter("view", item).startsWith("y")) {
                                calendarView = "view=y";
                                calendarMyear = getURLParameter("view", item).slice(getURLParameter("view", item).indexOf("y")+1);
                            }
                            // calendarView
                            else {
                                calendarView = "view=" + getURLParameter("view", item);
                            }
                        }

                        // calendarDate2
                        if (getURLParameter("date", item) != null) {
                            var date2regExp = /^\d{4}-\d{2}-\d{2}$/;
                            if (date2regExp.test(getURLParameter("date", item))) {
                                calendarDate = "";
                                calendarDate2 = getURLParameter("date", item);
                            }
                            // calendarDate
                            else {
                                calendarDate = "&date=" + getURLParameter("date", item);
                            }
                        }

                        // calendarEvents
                        if (getURLParameter("showStripes", item) != null) {
                            calendarEvents = "&showStripes=" + getURLParameter("showStripes", item);
                        }

                        // calendarLanguage
                        if (getURLParameter("lang", item) != null) {
                            calendarLanguage = "&lang=" + getURLParameter("lang", item);
                        }

                        // calendarTimezone
                        if (getURLParameter("tz", item) != null) {
                            calendarTimezone = getURLParameter("tz", item);
                        }

                        // calendarViewHeader
                        if (getURLParameter("showHeader", item) != null) {
                            calendarViewHeader = "&showHeader=" + getURLParameter("showHeader", item);
                        }

                        // calendarViewLogo
                        if (getURLParameter("showLogo", item) != null) {
                            calendarViewLogo = "&showLogo=" + getURLParameter("showLogo", item);
                        }

                        // calendarViewTitle
                        if (getURLParameter("showTitle", item) != null) {
                            calendarViewTitle = "&showTitle=" + getURLParameter("showTitle", item);
                        }

                        // calendarViewSelector
                        if (getURLParameter("showViewSelector", item) != null) {
                            calendarViewSelector = "&showViewSelector=" + getURLParameter("showViewSelector", item);
                        }

                        // calendarViewSidepanel
                        if (getURLParameter("showSidepanel", item) != null) {
                            calendarViewSidepanel = "&showSidepanel=" + getURLParameter("showSidepanel", item);
                        }
                        if (getURLParameter("disableSidepanel", item) != null) {
                            calendarViewSidepanel = "&disableSidepanel=" + getURLParameter("disableSidepanel", item);
                        }
                        // calendarRefresh
                        if (getURLParameter("refresh", item) != null) {
                            calendarRefresh = getURLParameter("refresh", item);
                        }

                    }
                });

                // Selected content is not Teamup Calendar
                if(!isCalendar) {

                    var win3 = editor.windowManager.open({
                        title: '📝 Selected content is not Teamup Calendar',
                        buttons: [
                            {
                            text: 'OK',
                            onclick: 'close',
                            subtype: 'primary'
                            }
                        ],
                        body: [
                            {type: 'container', name: '', label: 'Please select a Teamup Calendar or insert a new calendar on any empty space.'},
                        ]});
                    return;
                }
            }

// FORM INIT

            // Form Pre-selects (init)
            if (calendarWidth == "") {calendarWidth = "100%";}
            if (calendarHeight == "") {calendarHeight = "700";}
            if (calendarView == "") {calendarView = "";}
            if ((calendarMdays == "") && (actionName != "Edit")) {calendarMdays = "";}
            if ((calendarMweeks == "") && (actionName != "Edit")) {calendarMweeks = "";}
            if ((calendarMyear == "") && (actionName != "Edit")) {calendarMyea = "";}
            if (calendarDate == "") {calendarDate = "";}
            if (calendarViewHeader == "") {calendarViewHeader = "&showHeader=1";}
            if (calendarViewLogo == "") {calendarViewLogo = "&showLogo=1";}
            if (calendarViewTitle == "") {calendarViewTitle = "&showTitle=1";}
            if (calendarViewSidepanel == "") {calendarViewSidepanel = "&showSidepanel=1";}
            if (calendarViewSelector == "") {calendarViewSelector = "&showViewSelector=1";}
            
//EXECUTE COMMAND

            // Teamup Calendar button clicked
            var win = editor.windowManager.open({
                buttons: [
                {
                  text: actionName,
                  subtype: 'primary',
                  onclick: function(){

// VALIDATION ON SUBMIT

                    var heightValue = win.find('#height')[0];
                    heightValue = heightValue.value();
                    heightValue = heightValue.split("%").join("");

                    var widthValue = win.find('#width')[0];
                    widthValue = widthValue.value();
                    widthValue = widthValue.split("%").join("");

                    var date2Value = win.find('#date2')[0];
                    date2Value = date2Value.value();
                    var date2regEx = /^\d{4}-\d{2}-\d{2}$/;

                    var timezoneValue = win.find('#timezone')[0];
                    timezoneValue = timezoneValue.value();
                    var timezoneregEx = /^[^%]*\/[^%]*$/;

                    var urlValue = win.find('#url')[0];
                    var expression = /[-a-zA-Z0-9@:%_\+.~#?&//=]{2,256}\.[a-z]{2,4}\b(\/[-a-zA-Z0-9@:%_\+.~#?&//=]*)?/gi;
                    var regexUrl = new RegExp(expression);
                    urlValue = urlValue.value();

                    if(!((urlValue.match(regexUrl)) && (urlValue.indexOf("teamup.com/") !== -1) && (urlValue.indexOf("www.") == -1) && (urlValue.indexOf("ks") !== -1))) {

                        var win2 = editor.windowManager.open({
                        title: '⚠ Calendar URL',
                        buttons: [
                            {
                            text: 'OK',
                            onclick: 'close',
                            subtype: 'primary'
                            }
                        ],
                        body: [
                            {type: 'container', name: '', label: 'Specified Calendar URL is empty or invalid.'},
                        ]});

                    }
                    else if (isNaN(widthValue)) {

                        var win2 = editor.windowManager.open({
                        title: '⚠ Width',
                        buttons: [
                            {
                            text: 'OK',
                            onclick: 'close',
                            subtype: 'primary'
                            }
                        ],
                        body: [
                            {type: 'container', name: '', label: 'Specified calendar width is invalid.'},
                        ]});

                    }
                    else if (isNaN(heightValue)) {

                        var win2 = editor.windowManager.open({
                        title: '⚠ Height',
                        buttons: [
                            {
                            text: 'OK',
                            onclick: 'close',
                            subtype: 'primary'
                            }
                        ],
                        body: [
                            {type: 'container', name: '', label: 'Specified calendar height is invalid.'},
                        ]});

                    }
                    else if ((date2Value != "") && (!date2Value.match(date2regEx))) {

                        var win2 = editor.windowManager.open({
                        title: '⚠ Custom Start Date',
                        buttons: [
                            {
                            text: 'OK',
                            onclick: 'close',
                            subtype: 'primary'
                            }
                        ],
                        body: [
                            {type: 'container', name: '', label: 'Specified custom start date is invalid.'},
                        ]});

                    }
                    else if ((timezoneValue != "") && (!timezoneValue.match(timezoneregEx))) {

                        var win2 = editor.windowManager.open({
                        title: '⚠ Timezone',
                        buttons: [
                            {
                            text: 'OK',
                            onclick: 'close',
                            subtype: 'primary'
                            }
                        ],
                        body: [
                            {type: 'container', name: '', label: 'Specified timezone is invalid.'},
                        ]});

                    }
                    else {
                        win.submit();
                    }
                  }
                },
                {
                    text: 'Close',
                    onclick: 'close'
                    }
                ],

// FORM CONTENT

                title: 'Teamup Calendar',
                bodyType: 'tabpanel',
                body: [
                    {
                        title: '📆 General',
                        type: 'form',
                        items: [
                            {type: 'textbox', name: 'url', label: 'Calendar URL', value: calendarUrl, tooltip: 'Insert full calendar URL',
                                    onchange : function(v) {
                                        var du = win.find('#url')[0];
                                        var duVal = du.value();
                                        if (duVal.indexOf("?") !== -1) {
                                            duVal = duVal.split("?");
                                            du.value(duVal[0]);
                                        }
                                        duVal = du.value() + "";
                                        duVal = duVal.split("www.").join("");
                                        duVal = duVal.split("http://").join("https://");
                                        du.value(duVal);
                                    }
                            },
                            {type: 'textbox', name: 'title', label: 'Title', value: calendarTitle, tooltip: '(Optional) Insert custom calendar title'
                            },
                            {type: 'textbox', name: 'width', label: 'Width', value: calendarWidth, tooltip: 'Use percentage (%) or pixels'},
                            {type: 'textbox', name: 'height', label: 'Height', value: calendarHeight, tooltip: 'Use percentage (%) or pixels'},
                            {type: 'listbox', name: 'view', label: 'View', tooltip: 'Configures the view that is initially shown when the calendar is loaded', values: [
                                {text: '(Default)', value: ''},
                                {text: 'Week', value: 'view=w'},
                                {text: 'Day', value: 'view=d'},
                                {text: 'Month', value: 'view=m'},
                                {text: 'Multi Week', value: 'view=mw'},
                                {text: 'Multi Day', value: 'view=md'},
                                {text: 'Year', value: 'view=y'},
                                {text: 'Agenda', value: 'view=a'},
                                {text: 'List', value: 'view=l'},
                                {text: 'Scheduler', value: 'view=s'}
                            ], value: calendarView, 
                                onselect : function(v) {
                                    var md = win.find('#mdays')[0];
                                    var mw = win.find('#mweeks')[0];
                                    var my = win.find('#myear')[0];
                                    md.hide();
                                    mw.hide();
                                    my.hide();   
                                    if(this.value() == "view=md") {
                                        md.show();
                                    }
                                    if(this.value() == "view=mw") {
                                        mw.show();
                                    }
                                    if(this.value() == "view=y") {
                                        my.show();
                                    }
                                    else{

                                    }
                                }
                            },
                            {type: 'listbox', name: 'mdays', style: 'margin-left: 113px; max-width: 267px;', hidden: true, tooltip: 'Configures the number of days in Multi Day view', values: [
                                {text: '(Default)', value: ''},
                                {text: '2 Days', value: '2'},
                                {text: '3 Days', value: '3'},
                                {text: '4 Days', value: '4'},
                                {text: '5 Days', value: '5'},
                                {text: '6 Days', value: '6'}
                            ],
                            value: calendarMdays},
                            {type: 'listbox', name: 'mweeks', style: 'margin-left: 113px; max-width: 267px;', hidden: true, tooltip: 'Configures the number of weeks in Multi Week view', values: [
                                {text: '(Default)', value: ''},
                                {text: '2 Weeks', value: '2'},
                                {text: '3 Weeks', value: '3'},
                                {text: '4 Weeks', value: '4'},
                                {text: '5 Weeks', value: '5'},
                                {text: '6 Weeks', value: '6'},
                                {text: '7 Weeks', value: '7'},
                                {text: '8 Weeks', value: '8'},
                                {text: '9 Weeks', value: '9'},
                                {text: '10 Weeks', value: '10'},
                                {text: '11 Weeks', value: '11'},
                                {text: '12 Weeks', value: '12'}
                            ],
                            value: calendarMweeks},
                            {type: 'listbox', name: 'myear', style: 'margin-left: 113px; max-width: 267px;', hidden: true, tooltip: 'Configures the number of months in Multi Year view',values: [
                                {text: '(Default)', value: ''},
                                {text: '1 Month', value: '1m'},
                                {text: '2 Months', value: '2m'},
                                {text: '3 Months', value: '3m'},
                                {text: '4 Months', value: '4m'},
                                {text: '5 Months', value: '5m'},
                                {text: '6 Months', value: '6m'},
                                {text: '7 Months', value: '7m'},
                                {text: '8 Months', value: '8m'},
                                {text: '9 Months', value: '9m'},
                                {text: '10 Months', value: '10m'},
                                {text: '11 Months', value: '11m'},
                                {text: '12 Months', value: '12m'}
                            ],
                            value: calendarMyear}
                        ]
                    },
                    {
                        title: '🔧 Setup',
                        type: 'form',
                        items: [
                            {type: 'listbox', name: 'date', label: 'Start Date', tooltip: 'Configures the date that is initially set when the calendar is loaded.', values: [
                                {text: '(Default)', value: ''},
                                {text: 'Current Day', value: '&date=today'},
                                {text: '1st day of the current Month', value: '&date=m1'},
                                {text: '1st day of the current Quarter', value: '&date=q1'},
                                {text: '1st day of the current Year', value: '&date=y1'},
                                {text: 'Tomorrow', value: '&date=+1day'},
                                {text: '3 days from now', value: '&date=+3days'},
                                {text: '2 weeks from now', value: '&date=+2weeks'},
                                {text: '1 month from now', value: '&date=+1month'},
                                {text: '3 months from now', value: '&date=+3months'},
                                {text: '1 month in the past', value: '&date=-1month'},
                                {text: '1 week in the past', value: '&date=-1week'},
                                {text: '1 year from now', value: '&date=+1year'}
                            ],
                            value: calendarDate, 
                                onselect : function(v) {
                                    var dd2 = win.find('#date2')[0];
                                    dd2.value('');
                                }
                            },
                            {type: 'textbox', name: 'date2', label: 'Custom Start Date', value: calendarDate2, tooltip: '(Optional) This is useful for calendars that are used to plan for a specific event, like a conference',
                                    onchange : function(v) {
                                        var dd = win.find('#date')[0];
                                        dd.value('');
                                    }
                            },
                            {type: 'listbox', name: 'events', label: 'Event Boxes', tooltip: 'Configure how events assigned to multiple sub-calendars are visualized', values: [
                                {text: '(Default)', value: ''},
                                {text: 'Multiple Boxes', value: '&showStripes=0'},
                                {text: 'Stripes', value: '&showStripes=1'},
                            ],
                            value: calendarEvents},
                            {type: 'listbox', name: 'language', label: 'Language', tooltip: 'Configures the user interface language of the calendar', values: [
                                {text: '(Default)', value: ''},
                                {text: 'English US', value: '&lang=en'},
                                {text: 'English GB', value: '&lang=en_GB'},
                                {text: 'Czech', value: '&lang=cs'},
                                {text: 'Danish', value: '&lang=da'},
                                {text: 'German', value: '&lang=de'},
                                {text: 'Spanish', value: '&lang=es'},
                                {text: 'French', value: '&lang=fr'},
                                {text: 'Hungarian', value: '&lang=hu'},
                                {text: 'Italian', value: '&lang=it'},
                                {text: 'Portugese (Portugal)', value: '&lang=pt_PT'},
                                {text: 'Slovak', value: '&lang=sk'},
                                {text: 'Chinese (simplified)', value: '&lang=zh_CN'},
                                {text: 'Chinese (traditional)', value: '&lang=zh_TW'}
                            ],
                            value: calendarLanguage},
                            {type: 'textbox', name: 'timezone', label: 'Timezone', value: calendarTimezone, tooltip: '(Optional) Format: Asia/Tokyo. Forces the timezone of the calendar to a specific value'},
                            {type: 'container', name: 'container', label: '', html: '<p style="font-size: 14px; line-height: 1.5em;">Supported identifiers are defined in the <a href="https://en.wikipedia.org/wiki/List_of_tz_database_time_zones" target="_blank" style="font-size: 14px; text-decoration: underline; line-height: 1.5em;">timezone database<br>maintained by IANA</a>.</p>'}
                        ]
                    },
                    {
                        title: '📐 Layout',
                        type: 'form',
                        items: [
                            {type: 'listbox', name: 'sheader', label: 'Header', tooltip: 'Header includes the logo, the title and the search input', values: [
                                {text: 'Visible', value: '&showHeader=1'},
                                {text: 'Disabled', value: '&showHeader=0'}
                            ],
                            value: calendarViewHeader},
                            {type: 'listbox', name: 'slogo', label: 'Logo', tooltip: 'Visibility of the calendar logo', values: [
                                {text: 'Visible', value: '&showLogo=1'},
                                {text: 'Disabled', value: '&showLogo=0'}
                            ],
                            value: calendarViewLogo},
                            {type: 'listbox', name: 'stitle', label: 'Title', tooltip: 'Visibility of the calendar title', values: [
                                {text: 'Visible', value: '&showTitle=1'},
                                {text: 'Disabled', value: '&showTitle=0'}
                            ],
                            value: calendarViewTitle},
                            {type: 'listbox', name: 'ssidepanel', label: 'Sidepanel', tooltip: 'Visibility of the side panel when the calendar is initially started', values: [
                                {text: 'Visible', value: '&showSidepanel=1'},
                                {text: 'Collapsed', value: '&showSidepanel=0'},
                                {text: 'Disabled', value: '&disableSidepanel=1'}
                            ],
                            value: calendarViewSidepanel},
                            {type: 'listbox', name: 'sview', label: 'View Selector', tooltip: 'If the view selector is disabled, the user is not able to switch to a different calendar view', values: [
                                {text: 'Visible', value: '&showViewSelector=1'},
                                {text: 'Disabled', value: '&showViewSelector=0'}
                            ],
                            value: calendarViewSelector}
                        ]
                    },
                    {
                        title: '🌟 Premium',
                        type: 'form',
                        items: [
                            {type: 'listbox', name: 'refresh', label: 'Refresh', tooltip: 'Configure the interval', values: [
                                {text: 'No refresh', value: ''},
                                {text: '1 minute', value: '1'},
                                {text: '5 minutes', value: '5'},
                                {text: '10 minutes', value: '10'},
                                {text: '30 minutes', value: '30'},
                                {text: '1 hour', value: '60'},
                                {text: '6 hours', value: '600'},
                                {text: '12 hours', value: '1200'},
                                {text: '1 day', value: '2400'}
                            ],
                            value: calendarRefresh},
                            {type: 'container', name: 'container', label: '', html: '<p style="font-size: 14px; line-height: 1.5em;">The refresh parameter can be used to activate a periodic<br>refresh of the calendar. This parameter is only supported<br>with the <a href="http://www.teamup.com/pricing.html" target="_blank" style="font-size: 14px; text-decoration: underline; line-height: 1.5em;">Premium plan</a>.<br><br>Note that this parameter is only needed for exceptional use<br>cases, for example when the calendar is run on an unattended<br>display screen. In normal use, the calendar is refreshed when<br>users switch views, navigate between dates and other<br>interactions with the calendar.</p>'}
                        ]
                    },
                    {
                        title: '🌱 Help',
                        type: 'form',
                        items: [
                            {type: 'container', name: 'container', label: '', html: '<p style="font-size: 14px; line-height: 1.5em;">Below you can find various resources, which may help you<br>with settings or management of your calendar:<br><br><a href="https://calendar.teamup.com/kb/use-teamup-plugin-for-wordpress-sites/" target="_blank" style="font-size: 16px; font-weight: 600; text-decoration: underline; line-height: 1.5em;">Using Teamup Plugin</a><br><a href="https://www.teamup.com/help/general-help/" target="_blank" style="font-size: 16px; font-weight: 600; text-decoration: underline; line-height: 1.5em;">General Help</a><br><a href="http://calendar.teamup.com/kb-tags/faq/" target="_blank" style="font-size: 16px; font-weight: 600; text-decoration: underline; line-height: 1.5em;">FAQ</a><br><a href="https://www.teamup.com/help/getting-started/" target="_blank" style="font-size: 16px; font-weight: 600; text-decoration: underline; line-height: 1.5em;">Getting Started</a><br><a href="http://calendar.teamup.com/kb/" target="_blank" style="font-size: 16px; font-weight: 600; text-decoration: underline; line-height: 1.5em;">Knowledge Base</a><br><br>❤ Thank you for using Teamup Calendar!<br><p style="font-size: 12px;">(Check out our <a href="https://www.teamup.com/thanks-million/" target="_blank" style="font-size: 12px; text-decoration: underline; line-height: 1.5em;">Wall of Love</a>)</p></p>'}
                        ]
                    }
                ],

// FORM SUBMIT (VALIDATION OK)

                onsubmit: function(e) {
                    // Insert content when the window form is submitted

                    var alldata = win.toJSON();

                    var expression = /[-a-zA-Z0-9@:%_\+.~#?&//=]{2,256}\.[a-z]{2,4}\b(\/[-a-zA-Z0-9@:%_\+.~#?&//=]*)?/gi;
                    var regexUrl = new RegExp(expression);
                    var url = alldata.url;

                    if((url.match(regexUrl)) && (url.indexOf("teamup.com/") !== -1) && (url.indexOf("ks") !== -1)) {

                        // width & height
                        if(alldata.width == "") {alldata.width = "100%"};
                        if(alldata.height == "") {alldata.height = "700"};

                        // width & height (style)
                        var styleWidth = alldata.width;
                        var styleHeight = alldata.height;
                        if (styleWidth.slice(-1) != "%") { styleWidth = styleWidth + "px"; }
                        if (styleHeight.slice(-1) != "%") { styleHeight = styleHeight + "px"; }

                        if(alldata.view == "view=md") {
                            alldata.view = alldata.view + alldata.mdays;
                        };
                        if(alldata.view == "view=mw") {
                            alldata.view = alldata.view + alldata.mweeks;
                        };
                        if(alldata.view == "view=y") {
                            alldata.view = alldata.view + alldata.myear;
                        };

                        if(alldata.date2 != "") {
                            alldata.date = "&date=" + alldata.date2;
                        };

                        if(alldata.timezone != "") {
                            alldata.timezone = "&tz=" + alldata.timezone;
                        };

                        if(alldata.title != "") {
                            var titleText = encodeURIComponent(alldata.title);
                            alldata.title = "&title=" + titleText;
                        };

                        if(alldata.refresh != "") {
                            alldata.refresh = "&refresh=" + alldata.refresh;
                        };

                        var newContent = "<iframe src="+ alldata.url +"?"+ alldata.view + alldata.date + alldata.events + alldata.language + alldata.timezone + alldata.sheader + alldata.slogo + alldata.stitle + alldata.ssidepanel + alldata.sview + alldata.title + alldata.refresh +" frameborder='0' width="+ alldata.width +" height="+ alldata.height +" style='height: "+ styleHeight +"; width: "+ styleWidth +";'></iframe>";

                        editor.insertContent(newContent);

                    }
                    else {
                        editor.windowManager.open({
                        title: '🐳 Unexpected error occured',
                        body: [
                            {type: 'container', name: '', label: "If you are having problems with the plugin, please report it to us at support@teamup.com. Thank you!"},
                        ]});
                    }

                }
            });

// FORM INIT (PRE-SELECT)

            // Show Inputs
            var vv = win.find('#view')[0];
            var md = win.find('#mdays')[0];
            var mw = win.find('#mweeks')[0];
            var my = win.find('#myear')[0];
            md.hide();
            mw.hide();
            my.hide();   
            if(vv.value() == "view=md") {
                md.show();
            }
            if(vv.value() == "view=mw") {
                mw.show();
            }
            if(vv.value() == "view=y") {
                my.show();
            }

// DATEPICKER INIT

            // Flatpickr
            var dd2 = win.find('#date2')[0];
            var datepicker = flatpickr("#" + dd2._id, {
                "disableMobile" : true,
                "static" : true
            });

        });

    });
})();